diff --git a/gnu/packages/crypto.scm b/gnu/packages/crypto.scm
index 9dcffd8dd4..02d62ae19b 100644
--- a/gnu/packages/crypto.scm
+++ b/gnu/packages/crypto.scm
@@ -41,50 +41,60 @@
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
 (define-module (gnu packages crypto)
-  #:use-module (gnu packages)
-  #:use-module (gnu packages admin)
-  #:use-module (gnu packages aidc)
-  #:use-module (gnu packages attr)
-  #:use-module (gnu packages autotools)
-  #:use-module (gnu packages boost)
-  #:use-module (gnu packages check)
-  #:use-module (gnu packages compression)
-  #:use-module (gnu packages cpp)
-  #:use-module (gnu packages crates-io)
-  #:use-module (gnu packages cryptsetup)
-  #:use-module (gnu packages curl)
-  #:use-module (gnu packages documentation)
-  #:use-module (gnu packages gettext)
-  #:use-module (gnu packages gnupg)
-  #:use-module (gnu packages golang)
-  #:use-module (gnu packages graphviz)
-  #:use-module (gnu packages image)
-  #:use-module (gnu packages kerberos)
-  #:use-module (gnu packages libbsd)
-  #:use-module (gnu packages libffi)
-  #:use-module (gnu packages linux)
-  #:use-module (gnu packages logging)
-  #:use-module (gnu packages lsof)
-  #:use-module (gnu packages man)
-  #:use-module (gnu packages multiprecision)
-  #:use-module (gnu packages nettle)
-  #:use-module (gnu packages password-utils)
-  #:use-module (gnu packages perl)
-  #:use-module (gnu packages perl-check)
-  #:use-module (gnu packages pkg-config)
-  #:use-module (gnu packages python)
-  #:use-module (gnu packages python-xyz)
-  #:use-module (gnu packages python-check)
-  #:use-module (gnu packages python-crypto)
-  #:use-module (gnu packages readline)
-  #:use-module (gnu packages search)
-  #:use-module (gnu packages serialization)
-  #:use-module (gnu packages shells)
-  #:use-module (gnu packages sqlite)
-  #:use-module (gnu packages tcl)
-  #:use-module (gnu packages tls)
-  #:use-module (gnu packages version-control)
-  #:use-module (gnu packages xml)
+  #:autoload (gnu packages admin) (sudo)
+  #:autoload (gnu packages aidc) (qrencode)
+  #:autoload (gnu packages attr) (attr)
+  #:autoload (gnu packages autotools) (autoconf automake libtool)
+  #:autoload (gnu packages boost) (boost)
+  #:autoload (gnu packages check) (googletest python-pytest)
+  #:autoload (gnu packages compression) (bzip2 unzip zlib)
+  #:autoload (gnu packages cpp) (range-v3)
+  #:autoload (gnu packages crates-io)
+  (rust-anyhow-1 rust-arrayref-0.3 rust-arrayvec-0.5 rust-arrayvec-0.7
+                 rust-cc-1 rust-cfg-if-0.1 rust-cfg-if-1 rust-clap-2
+                 rust-constant-time-eq-0.1 rust-crypto-mac-0.11
+                 rust-crypto-mac-0.8 rust-digest-0.9 rust-duct-0.13
+                 rust-getrandom-0.1 rust-hex-0.4 rust-memmap-0.7
+                 rust-page-size-0.4 rust-rand-0.8 rust-rand-chacha-0.3
+                 rust-rayon-1 rust-rpassword-4 rust-scrypt-0.3
+                 rust-tempfile-3 rust-wild-2)
+  #:autoload (gnu packages cryptsetup) (cryptsetup)
+  #:autoload (gnu packages curl) (curl)
+  #:autoload (gnu packages documentation) (doxygen)
+  #:autoload (gnu packages gettext) (gettext-minimal)
+  #:autoload (gnu packages gnupg) (gnupg pinentry)
+  #:autoload (gnu packages golang) (go-golang-org-x-crypto)
+  #:autoload (gnu packages graphviz) (graphviz)
+  #:autoload (gnu packages image) (steghide)
+  #:autoload (gnu packages kerberos) (mit-krb5)
+  #:autoload (gnu packages libbsd) (libbsd)
+  #:autoload (gnu packages libffi) (python-cffi)
+  #:autoload (gnu packages linux) (e2fsprogs fuse util-linux)
+  #:autoload (gnu packages logging) (spdlog)
+  #:autoload (gnu packages lsof) (lsof)
+  #:autoload (gnu packages man) (xmltoman)
+  #:autoload (gnu packages multiprecision) (gmp)
+  #:autoload (gnu packages nettle) (nettle)
+  #:autoload (gnu packages perl)
+  (perl perl-capture-tiny perl-list-moreutils perl-module-build
+        perl-module-build-tiny perl-module-find perl-module-runtime
+        perl-moo perl-namespace-clean perl-sub-exporter perl-type-tiny)
+  #:autoload (gnu packages pkg-config) (pkg-config)
+  #:autoload (gnu packages perl-check)
+  (perl-test-fatal perl-test-leaktrace perl-test-nowarnings
+                   perl-test-sharedfork perl-test-warn)
+  #:autoload (gnu packages python) (python-wrapper python-3)
+  #:autoload (gnu packages python-xyz)
+  (python-aspectlib python-docutils python-future)
+  #:autoload (gnu packages python-check) (python-pytest-benchmark)
+  #:autoload (gnu packages python-crypto) (python-passlib)
+  #:autoload (gnu packages search) (mlocate)
+  #:autoload (gnu packages shells) (zsh)
+  #:autoload (gnu packages sqlite) (sqlite)
+  #:autoload (gnu packages tcl) (expect)
+  #:autoload (gnu packages tls) (openssl)
+  #:autoload (gnu packages version-control) (git)
+  #:autoload (gnu packages xml) (libxml2 tinyxml2)
   #:use-module ((guix licenses) #:prefix license:)
   #:use-module (guix packages)
   #:use-module (guix download)