diff --git a/gnu/packages/tree-sitter.scm b/gnu/packages/tree-sitter.scm
index d0214f3a12..d23fa2fbd8 100644
--- a/gnu/packages/tree-sitter.scm
+++ b/gnu/packages/tree-sitter.scm
@@ -21,6 +21,7 @@ (define-module (gnu packages tree-sitter)
   #:use-module (guix gexp)
   #:use-module ((guix licenses) #:prefix license:)
   #:use-module (guix build-system cargo)
+  #:use-module (guix build-system emacs)
   #:use-module (guix build-system gnu)
   #:use-module (guix build-system tree-sitter)
   #:use-module (guix download)
@@ -738,3 +739,86 @@ (define-public tree-sitter-typescript
      "This package provides Typescript and TSX grammars for the Tree-sitter
 library.")
     (license license:expat)))
+
+;; Local package definition solely for building the native emacs module
+;; written in Rust.
+(define tree-sitter-emacs-module
+  (package
+    (name "tree-sitter-emacs-module")
+    (version "0.18.0")
+    (source (origin
+              (method git-fetch)
+              (uri (git-reference
+                    (url "https://github.com/emacs-tree-sitter/elisp-tree-sitter")
+                    (commit version)))
+              (file-name (git-file-name name version))
+              (sha256
+               (base32
+                "1sdvz827v436qijs6xafakkfw2d16bvp8frymd818rppjc7a9dif"))))
+    (build-system cargo-build-system)
+    (inputs
+     (list tree-sitter))
+    (arguments
+     `(#:cargo-inputs
+       (("rust-anyhow" ,rust-anyhow-1)
+        ("rust-emacs" ,rust-emacs-0.18)
+        ("rust-libloading" ,rust-libloading-0.7)
+        ("rust-once-cell" ,rust-once-cell-1)
+        ("rust-tree-sitter" ,rust-tree-sitter-for-emacs))
+       #:phases
+       (modify-phases %standard-phases
+         (add-after 'unpack 'chdir
+           (lambda _ (chdir "core")))
+         (add-after 'chdir 'delete-cargo.lock
+           (lambda _ (delete-file "Cargo.lock")))
+         (add-after 'delete-cargo.lock 'do-not-fetch-from-github
+           (lambda _
+             (substitute* "Cargo.toml"
+               (("\\[patch.*") "")
+               (("git = .*") ""))))
+         (replace 'install
+           (lambda* (#:key outputs #:allow-other-keys)
+             (let ((lib (string-append (assoc-ref outputs "out") "/lib")))
+               (mkdir-p lib)
+               (copy-file "target/release/libtsc_dyn.so"
+                          (string-append lib "/tsc-dyn.so"))))))))
+    (home-page #f)
+    (synopsis #f)
+    (description #f)
+    (license license:expat)))
+
+(define-public emacs-tree-sitter-core
+  (package
+    (name "emacs-tree-sitter-core")
+    (version (package-version tree-sitter-emacs-module))
+    (source (package-source tree-sitter-emacs-module))
+    (build-system emacs-build-system)
+    (native-inputs
+     (list tree-sitter-emacs-module))
+    (arguments
+     `(#:phases
+       (modify-phases %standard-phases
+         (add-after 'unpack 'chdir
+           (lambda _ (chdir "core")))
+         (add-before 'install 'find-tsc-dyn
+           (lambda* (#:key inputs outputs #:allow-other-keys)
+             (let ((elpa (elpa-directory (assoc-ref outputs "out")))
+                   (module (search-input-file inputs "/lib/tsc-dyn.so")))
+               ;; Install the tsc-dyn module in site-lisp and the current
+               ;; directory for test to pass.
+               (install-file module elpa)
+               (copy-file module "tsc-dyn.so")
+               ;; We replace the tsc-dyn-get.el file with an empty stub to
+               ;; prevent the code from downloading the module.
+               (call-with-output-file "tsc-dyn-get.el"
+                 (lambda (port)
+                   (for-each
+                    (lambda (sexp) (write sexp port))
+                    '((defun tsc-dyn-get-ensure (requested)
+                        nil)
+                      (provide 'tsc-dyn-get)))))))))))
+    (home-page "https://github.com/emacs-tree-sitter/elisp-tree-sitter")
+    (synopsis "Tree-sitter bindings for Emacs Lisp, core library")
+    (description "This package provides core APIs of the Emacs binding for
+Tree-sitter, an incremental parsing system.")
+    (license license:expat)))